# libdir independent location, i.e. always /usr/lib/yaboot/
%define yabootdir %{_prefix}/lib/yaboot

# define to use "ofpath" from the powerpc-utils package (default for ppc64)
%define ppcutils_ofpath 0
%ifarch ppc64
%define ppcutils_ofpath 1
%endif

Summary:	New World Mac Bootloader
Name:		yaboot
Version:	1.3.13
Release:	8mdk
License:	GPL
Group:		System/Kernel and hardware
ExclusiveArch: 	ppc ppc64

Source:		http://penguinppc.org/usr/yaboot/yaboot-%{version}.tar.bz2
Patch1: 	yaboot-1.3.3-man.patch.bz2
Patch2: 	yaboot-1.3.6-ofboot.patch.bz2
Patch3:		yaboot-1.3.13-ofpath-usb-storage.patch.bz2
Patch4:		yaboot-1.3.13-buildfix.patch.bz2
Patch5:		yaboot-1.3.13-ofpath-sbp2.patch.bz2
Patch6:		yaboot-1.3.13-ofpath-disable-devicetree-check.patch.bz2
Patch7:		yaboot-1.3.13-ppc64.patch.bz2
Patch8:		yaboot-1.3.13-netboot.patch.bz2
Patch9:		yaboot-1.3.13-confarg.patch.bz2
Patch10:	yaboot-1.3.13-ibm-vscsi.patch.bz2
Patch11:	yaboot-1.3.13-ybin-raw-install-return0.patch.bz2

Url:		http://penguinppc.org/projects/yaboot/
BuildRoot:	%_tmppath/%name-%version-root

Requires(post):	powerpc-utils >= 0.0.1-4mdk
Requires: powerpc-utils >= 0.0.1-4mdk
Provides: bootloader ybin

%description
Ybin is a GNU/Linux utility to install the yaboot  boot loader onto a 
bootstrap partition. It will not run from MacOS.                        

Yaboot is the bootloader for NewWorld PowerMacs and  IBM CHRP hardware 
architectures. It will not work on OldWorld PowerMacs. 
                       
ybin (YaBoot INstaller) was created so that there could be a lilo/quik 
style bootloader installer for PowerPC based machines which require 
bootstrap partitions rather then a traditional bootblock (ie all 
`newworld' Macintoshes). It is designed to install yaboot, an  
OpenFirmware bootloader for GNU/Linux written by Benjamin Herrenschmidt. 
When ybin is configured correctly you can simply type ybin, and the 
bootloader and its configuration will be installed/updated on the 
bootstrap partition without any further user intervention.  ybin also 
supports IBM bootstrap partitions. 

%prep
%setup -q
%patch1 -p0
%patch2 -p1
%patch3 -p1 -b .usb-storage
%patch4 -p1 -b .fix
%patch5 -p1 -b .sbp2
%patch6 -p1 -b .disable-devicetree-check
%patch7 -p1 -b .ppc64
%patch8 -p1 -b .netboot
%patch9 -p1 -b .confarg
%patch10 -p1 -b .ibm-vscsi
%patch11 -p1 -b .ybin-raw-install-return0

#change some install paths
perl -pi -e 's|-o root -g root||g' Makefile
#bzip man-pages
perl -pi -e 's|gzip -9|bzip2 -9|g' Makefile
perl -pi -e 's|8.gz|8.bz2|g' Makefile
perl -pi -e 's|5.gz|5.bz2|g' Makefile
perl -pi -e 's|gunzip man/\*.gz|bunzip2 man/\*.bz2|g' Makefile

%build
%make

%install
%makeinstall ROOT=$RPM_BUILD_ROOT PREFIX=%{_prefix} MANDIR=share/man

%if %{ppcutils_ofpath}
rm -f $RPM_BUILD_ROOT%{_sbindir}/ofpath
rm -f $RPM_BUILD_ROOT%{_mandir}/man8/ofpath.8.bz2
%endif

%clean
rm -fr %buildroot

%post
USELOCAL=`grep '\/usr\/local' /etc/yaboot.conf`
if [ -n "$USELOCAL" ]; then
perl -pi -e 's|/usr/local|/usr|g' /etc/yaboot.conf
fi
/usr/sbin/ybin
true

%files
%defattr(-,root,root)
%doc COPYING README* doc/*
%config(noreplace) /etc/yaboot.conf
%{_sbindir}/ybin
%{_sbindir}/yabootconfig
%{_sbindir}/mkofboot
%{yabootdir}/addnote
%{yabootdir}/ofboot
%{yabootdir}/yaboot
%{_mandir}/man8/bootstrap.8.bz2
%{_mandir}/man8/mkofboot.8.bz2
%{_mandir}/man8/yaboot.8.bz2
%{_mandir}/man8/ybin.8.bz2
%{_mandir}/man5/yaboot.conf.5.bz2
%{_mandir}/man8/yabootconfig.8.bz2
%if ! %{ppcutils_ofpath}
%{_sbindir}/ofpath
%{_mandir}/man8/ofpath.8.bz2
%endif

%changelog
* Sun Feb 12 2006 Christiaan Welvaart <cjw@daneel.dyndns.org> 1.3.13-8mdk
- do not use powerpc-utils ofpathname for ppc
  (but keep powerpc-utils in basesystem anyway)

* Wed Jan 18 2006 Gwenole Beauchesne <gbeauchesne@mandriva.com> 1.3.13-7mdk
- use more robust "ofpath" from powerpc-utils package

* Tue Dec 13 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 1.3.13-6mdk
- return 0 when raw_install() is done
- first attempt at handling IBM,v-scsi disks

* Tue Nov 22 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 1.3.13-5mdk
- fix build on ppc64 (compile as a 32-bit application)
- merge with Fedora package 1.3.13-0.16:
  * netboot fixes
  * handle conf= command line option

* Sun Oct 09 2005 Christiaan Welvaart <cjw@daneel.dyndns.org> 1.3.13-4mdk
- fix patch5 for removal of symlinks from /proc/device-tree
- patch6: disable broken /proc/device-tree check
- make post install script exit with 0 even when ybin fails

* Fri Oct 07 2005 Stew Benedict <sbenedict@mandriva.com> 1.3.13-3mdk
- birthday rebuild

* Wed Sep 08 2004 Christiaan Welvaart <cjw@daneel.dyndns.org> 1.3.13-2mdk
- Patch5: experimental support for sbp2 (ieee1394 block devices)

* Thu Jul 29 2004 Christiaan Welvaart <cjw@daneel.dyndns.org> 1.3.13-1mdk
- 1.3.13
- Patch3: experimental support for USB storage devices
- Patch4: fix compilation of lib/strstr.c

* Mon May  3 2004 Stew Benedict <sbenedict@mandrakesoft.com> 1.3.12-1mdk
- 1.3.12

* Wed Jan  7 2004 Stew Benedict <sbenedict@mandrakesoft.com> 1.3.11-1mdk
- 1.3.11, provides bootloader

* Mon Jun  9 2003 Stew Benedict <sbenedict@mandrakesoft.com> 1.3.10-1mdk
- 1.3.10 - drop patch3 - fixed upstream, drop patch 4
- RS6K uses a slightly different yaboot.conf format

* Tue Mar  4 2003 Stew Benedict <sbenedict@mandrakesoft.com> 1.3.9-2mdk
- add patch4 - fix RS6000 detection of -1 as default partition

* Tue Feb 25 2003 Stew Benedict <sbenedict@mandrakesoft.com> 1.3.9-1mdk
- 1.3.9 - needed for new TiBooks, new man page

* Mon Dec 30 2002 Stew Benedict <sbenedict@mandrakesoft.com> 1.3.8-2mdk
- rebuild for new glib/rpm - patch ofpath for old iMacs

* Tue Dec  9 2002 Stew Benedict <sbenedict@mandrakesoft.com> 1.3.8-1mdk
- 1.3.8

* Sat Nov 16 2002 Stew Benedict <sbenedict@mandrakesoft.com> 1.3.7-4mdk
- update old yaboot.conf paths in %%post if necessary

* Mon Oct 21 2002 Stew Benedict <sbenedict@mandrakesoft.com> 1.3.7-3mdk
- fix %%post

* Mon Oct 21 2002 Stew Benedict <sbenedict@mandrakesoft.com> 1.3.7-2mdk
- rework ofboot patch (patch2 - boot banner)

* Wed Oct  9 2002 Stew Benedict <sbenedict@mandrakesoft.com> 1.3.7-1mdk
- new version, clean up spec file, file locations

* Fri Dec 14 2001 Stew Benedict <sbenedict@mandrakesoft.com> 1.3.6-1mdk
- new version IBM CHRP support back, updated documentation

* Wed Nov 28 2001 Stew Benedict <sbenedict@mandrakesoft.com> 1.3.5-1mdk
- new version, journalled FS support

* Wed Oct 17 2001 Stew Benedict <sbenedict@mandrakesoft.com> 1.3.4-1mdk
- merge of yaboot/ybin projects, new version, change package name

* Fri May 25 2001 Stew Benedict <sbenedict@mandrakesoft.com> 0.30-4mdk
- really fix makefile - mkofboot symlink still broke

* Thu May 10 2001 Stew Benedict <sbenedict@mandrakesoft.com> 0.30-3mdk
- really fix makefile - mkofboot in /sbin too

* Mon Feb 12 2001 Stew Benedict <sbenedict@mandrakesoft.com> 0.30-2mdk
- moved ybin to /sbin - root level utility

* Mon Feb 12 2001 Stew Benedict <sbenedict@mandrakesoft.com> 0.30-1mdk
- packaged as RPM

